/* シリアルポートから取り込んだカンマ区切りデータに従い
 * ＲＣサーボにデータを送る。
 */

#include <Servo.h>

#define SVPITCH  9   // ピッチサーボ
#define SVBANK  10   // バンクサーボ
Servo pitchservo;
Servo bankservo;

int pmod = 15;
int bmod = 15;
char buff[256];
int pitch;
int bank;
int temp;
int counter=0;

void setup() {
  pitchservo.attach(SVPITCH);
  bankservo.attach(SVBANK);
  pitchservo.writeMicroseconds(1500);
  bankservo.writeMicroseconds(1500);
  Serial.begin(115200);
}

void loop() {
  if (Serial.available()) {
    buff[counter] = Serial.read();
    if (counter > 256 || buff[counter] == '\n') {
      buff[counter] = '\0';
      // 受信文字列をカンマ区切りにしてatoi
      pitch=atoi(strtok(buff,","));
      bank =atoi(strtok(NULL,","));
      temp =atoi(strtok(NULL,","));

      int pitchwidth=1500+pitch*pmod/18;
      int bankwidth=1500+bank*pmod/18;
      if (pitchwidth < 1000) { pitchwidth=1000;}
      if (2000 < pitchwidth) { pitchwidth=2000;}
      if (bankwidth  < 1000) { bankwidth =1000;}
      if (2000 <  bankwidth) { bankwidth =2000;}
      
      //最初の要素だけ抽出
       pitchservo.writeMicroseconds(1500+pitch*pmod/18);
       bankservo.writeMicroseconds(1500+bank*pmod/18);

      // カウンタの初期化
      counter = 0;
    }
    else { counter++; }
  }
}
